/*******************************************************************
 ** SAIDESU  V1.0 96/06/23  Nob_Kozawa  PAF00521@niftyserve.co.jp **
 *******************************************************************/

RC = RxFuncAdd('RXGETSHIFTSTATE', 'FD2', 'RXGETSHIFTSTATE')
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

parse value SysTextScreenSize() with ROW COL .
BOXX = 5; BOXY = 20; BAR = copies(' ',BOXY)
parse value (ROW - BOXX * 2 + 4) / 2 with LSX '.' .
RSX = LSX; LCX = LSX + BOXX + 2; RCX = LCX
parse value (COL - BOXY * 2 - 6) / 2 with LSY '.' .
LCY = LSY; RCY = LCY + BOXY + 6; RSY = RCY
MSGX = LSX % 2 + 1
MSGY = 2
MSGL = COL - 4

call SETUP
call DISPFRAME
call DISPKEYS

call DRAWLS 200
call DRAWLC 200
call DRAWRS 200
call DRAWRC 200

call DRAWLS 14
call DRAWLC 14
call DRAWRS 14
call DRAWRC 14

LOOP = 50
SAVEHIGH = 0
HIGHSCORE = SysIni(,'SAIDESU','HIGH')
if HIGHSCORE = 'ERROR:' then HIGHSCORE = 0
else SAVEHIGH = HIGHSCORE
call DISPHIGH

do forever
   call DISPMSG 7,"Press 'S' to start,'E' to exit or 'C' to clear HIGHSCORE"
   do forever
      parse upper value SysGetKey('noecho') with KK
      select
         when KK = 'S' then leave
         when KK = 'E' then do
            if HIGHSCORE <> 0 & HIGHSCORE <> SAVEHIGH then do
               call DISPMSG 0,''
               call GOTOXY MSGX LSY
               call charout ,'Store HIGHSCORE ? (Y/n):'
               pull XX
               if XX = '' | left(XX,1) = 'Y' then do
                  call SysIni ,'SAIDESU','HIGH',HIGHSCORE
               end  /* Do */
            end  /* Do */
            call GOTOXY ROW,0
            x = charout(,CCLR.0)
            exit
         end  /* Do */
         when KK = 'C' then do
            call SysIni ,'SAIDESU','HIGH','DELETE:'
            HIGHSCORE = 0
            call DISPHIGH
         end  /* Do */
      otherwise nop
      end  /* select */
   end /* do */
   call DISPMSG 7,'Game will start soon.'
   call SysSleep 1
   MEMORY. = 0
   do I = 1 to LOOP
      select
         when I <= 5 then TIME = 500
         when 5 < I | I <= 10 then TIME = 250
         when 10 < I | I <= 15 then TIME = 200
         when 15 < I | I <= 20 then TIME = 150
      otherwise TIME = 100
      end  /* select */
   
      MEMORY.I = random(1,4)
      call DOPAD
      if 0 <> GETPAD() then leave
      call SysSleep 1
   end /* do */

   if word(HIGHSCORE,1) <= I - 1 then do
      HIGHSCORE = I - 1 '['date() time()']'
      call DISPHIGH
      call DISPMSG 2,'Good !  Highscore has been updated.'
   end
   call SysSleep 1
   call DRAWALL
   if I > LOOP then do
      call DISPMSG 2,'Congratulation !!'
      call beep 524,100;call beep 330,200; call beep 349,400
      call beep 440,200; call beep 494,200; call beep 524,200
   end  /* Do */
   else do
      call beep 110,300
      do I = 0 to 2000
      end /* do */
      call beep 110,600
   end  /* Do */
   call DRAWALL 'X'
end /* do */
exit

DOPAD:
   call DISPMSG 6,'Level =' I
   do J = 1 to I
      PAD = MEMORY.J
      select
         when PAD = 1 then call DRAWLS TIME
         when PAD = 2 then call DRAWRS TIME
         when PAD = 3 then call DRAWLC TIME
         when PAD = 4 then call DRAWRC TIME
      otherwise nop
      end  /* select */
   end /* do */
return

DOPADX:
   do J = 1 to I
      PAD = MEMORY.J
      x = charout(,PAD)
   end /* do */
   say ''
   say TIME
return

GETPAD:
   RC = 0
   call DISPMSG 6,'Your turn !'
   do until KEY = '000000'x
      KEY = bitand('070500'x, RXGETSHIFTSTATE())
   end
   do J = 1 to I
      do until PAD <> 0
         KEY = bitand('070500'x, RXGETSHIFTSTATE())
         select
            when KEY = '020000'X then PAD = 1
            when KEY = '010000'X then PAD = 2
            when KEY = '040100'X then PAD = 3
            when KEY = '040400'X then PAD = 4
         otherwise PAD = 0
         end  /* select */
      end /* do */
      if MEMORY.J = PAD then do
         select
            when PAD = 1 then call DRAWLS 200
            when PAD = 2 then call DRAWRS 200
            when PAD = 3 then call DRAWLC 200
            when PAD = 4 then call DRAWRC 200
         otherwise nop
         end  /* select */
         do until KEY <> KEY2
            KEY2 = bitand('070500'x, RXGETSHIFTSTATE())
         end 
      end  /* Do */
      else do
         call DISPMSG 5,'FAILED'
         call beep 55,300
         RC = 1
         leave
      end  /* Do */
   end /* do */
return  RC

DISPMSG:
  parse arg CLR,MSG
  call GOTOXY MSGX MSGY
  x = charout(,CCLR.CLR||center(MSG,MSGL))
return

DRAWALL:
  arg CC
  if CC = '' then do
     call DRAWBOX LSX, LSY, 8
     call DRAWBOX LCX, LCY, 9
     call DRAWBOX RCX, RCY, 10
     call DRAWBOX RSX, RSY, 11
  end  /* Do */
  else do
     call DRAWBOX LSX, LSY, 14
     call DRAWBOX LCX, LCY, 14
     call DRAWBOX RCX, RCY, 14
     call DRAWBOX RSX, RSY, 14
  end  /* Do */
return

DRAWLS:
  arg CC
  call DRAWBOX LSX, LSY, 8
  call beep 131,CC
  call DRAWBOX LSX, LSY, 14
return

DRAWLC:
  arg CC
  if CC = '' then CC = 9
  call DRAWBOX LCX, LCY, 9
  call beep 330,CC
  call DRAWBOX LCX, LCY, 14
return

DRAWRC:
  arg CC
  call DRAWBOX RCX, RCY, 10
  call beep 784,CC
  call DRAWBOX RCX, RCY, 14
return

DRAWRS:
  arg CC
  call DRAWBOX RSX, RSY, 11
  call beep 524,CC
  call DRAWBOX RSX, RSY, 14
return

DRAWBOX:
  arg XX, YY, COLOR
  do DRW = 0 to BOXX - 1
     call GOTOXY XX+DRW YY
     call charout ,CCLR.COLOR||BAR||CCLR.0
  end /* do */
return

SETUP:
   CCLR.0 = '1B'x||'[0m'                 /* No attribute */
   CCLR.1 = 'WHBL'                         /* Frame */
   CCLR.2 = 'HYE'         
   CCLR.3 = 'PU'            
   CCLR.4 = 'BL'            
   CCLR.5 = 'RE'
   CCLR.6 = 'TU'            
   CCLR.7 = 'HWH'           
   CCLR.19 = 'RV'          
   CCLR.8 = 'HWHRE'                    /* Left Shift */
   CCLR.9 = 'HWHYE'                    /* Left Ctrl */
   CCLR.10= 'HWHTU'                    /* Right Ctrl */
   CCLR.11= 'HWHPU'                    /* Right Shift */
   CCLR.12= 'HBKGR'
   CCLR.13 = 'BKTU'         
   CCLR.14 = 'BKWH'         
   CCLR.15 = 'BKGR'        
   CCLR.16 = 'BKTU'         
   CCLR.17 = 'REBK'         
   CCLR.18 = 'BKRE'         

   call SETCOLOR 19

  options 'exmode'
  if NETMODE = 1 then do
     CUL = '+'; CH = '-'; CUR ='+'            /*     */
     CV = '|'                                 /*   */
     CVL = '+'; CVR = '+'                     /*    */
     CLL = '+'; CLR = '+'                     /*    */
  end  /* Do */
  else do
    if filespec('N','\') = '\' then do
       CUL = '1'x; CH = '6'x; CUR ='2'X             /*     */
       CV = '5'x                                    /*   */
       CVL = '19'x; CVR = '17'x                     /*    */
       CLL = '3'X; CLR = '4'X                       /*    */
    end  /* Do */
    else do
       CUL = 'C9'x; CH = 'CD'x; CUR ='BB'x          /*     */
       CV = 'BA'x                                   /*   */
       CVL = 'CC'x; CVR = 'B9'x                     /*    */
       CLL = 'C8'x; CLR = 'BC'x                     /*    */
    end  /* Do */
  end
  options 'noexmode'
return

DISPHIGH:
  call GOTOXY 3 3
  x = charout(,CCLR.7||left('HIGH SCORE :' HIGHSCORE,COL-5))
return

DISPKEYS:
  call GOTOXY LSX-1 LSY
  x = charout(,CCLR.8||center('Left Shift',BOXY))
  call GOTOXY RSX-1 RSY
  x = charout(,CCLR.11||center('Right Shift',BOXY))
  call GOTOXY LCX-1 LCY
  x = charout(,CCLR.9||center('Left Ctrl',BOXY))
  call GOTOXY RCX-1 RCY
  x = charout(,CCLR.10||center('Right Ctrl',BOXY))
return

DISPFRAME: procedure expose ROW COL CCLR.0 CCLR.1 CCLR.2,    /* Draw frame */
                            CUL CH CUR CV CVL CVR CLL CLR TITLE,
                            DEBUGQ DEBUG
  call SysCurState 'OFF'
  YY = COL - 3
  call CLS
  Z=charout(,CCLR.1||CUL||copies(CH,YY)||CUR||CCLR.0||'0d0a'X)          /**/
  do I = 3 to ROW
    Z=charout(,CCLR.1||CV||CCLR.0||copies(' ',YY)||CCLR.1||CV||CCLR.0||'0d0a'x) /* File area  */
  end /* do */                                       
  X = charout(,CCLR.1||CLL||copies(CH,YY)||CCLR.1||CLR||CCLR.0)        /**/
return

GOTOXY: procedure                        /* Move the cursor */
arg X Y
  /* Z = syscurpos(X, Y) */
  Z = charout(,'1B'X||'['||X||';'||Y||'H')
return

CLS: procedure                           /* Clear screen */
  X = charout(,'1B'x||'[2J')
return

SETCOLOR: procedure expose CCLR. ROW DEBUGQ DEBUG
  arg NUM
  do I = 1 to NUM
     parse upper value CCLR.I with X
     XX = '1B'X||'[0;'; P = 2
     if left(CCLR.I,1) = 'H' then XX = XX||'1;'
     else P = 1
     XX = XX||GETC(substr(X,P,2))
     call GETC substr(X,P+2,2)
     if result <> '' then result = ';'||(result + 10)
     XX = XX||result||'m'
     CCLR.I = XX
  end /* do */
return

GETC: procedure
  arg CC
  select
     when CC = 'BK' then VL = 30
     when CC = 'RE' then VL = 31
     when CC = 'GR' then VL = 32
     when CC = 'YE' then VL = 33
     when CC = 'BL' then VL = 34
     when CC = 'PU' then VL = 35
     when CC = 'TU' then VL = 36
     when CC = 'WH' then VL = 37
     when CC = 'RV' then VL = 7
     otherwise VL = ''
  end  /* select */
return VL
